<?php

class pp3 {
  var $code, $title, $description, $enabled, $sort_order, $form_action_url, $cc_card_number;

  // class constructor
  function pp3() {
    $this->code = 'pp3';
    $this->title = MODULE_PAYMENT_PP3_TEXT_TITLE;
    $this->description = MODULE_PAYMENT_PP3_TEXT_DESCRIPTION;
	$this->password = MODULE_PAYMENT_PP3_PASSWORD;
    $this->enabled = (MODULE_PAYMENT_PP3_STATUS == 'True') ? true : false;
    $this->sort_order = MODULE_PAYMENT_PP3_SORTORDER; 
    $this->form_action_url = (MODULE_PAYMENT_PP3_PRODUCTION == 'True')? MODULE_PAYMENT_PP3_PROD_URL : MODULE_PAYMENT_PP3_TEST_URL;
    $this->ref = '';
  }
  
//get customer info
function customer() {
global $order;
$customer_id = $_SESSION['customer_id'];
$customer_query = tep_db_query("select customers_firstname, customers_lastname, customers_email_address from " . TABLE_CUSTOMERS . " where customers_id = '" . (int)$customer_id . "'");
$customer = tep_db_fetch_array($customer_query);
$customer_fname =  $customer['customers_firstname'];
$customer_lname =  $customer['customers_lastname'];
$customer_email =  $customer['customers_email_address'];

$customer_info = array('fname' => $customer_fname,'lname' => $customer_lname,'email' => $customer_email);
return $customer_info;
}

  // class methods
  function javascript_validation() {
    return;
  }

  function selection() {
    global $order;

    $card_accepted = array('' =>'', 'EmporoKarta' => 'EmporoKarta', 'MasterCard' => 'MasterCard', 'VISA' => 'VISA');
	  reset($card_accepted);
	  while (list($key, $val) = each($card_accepted)) {
	  $cc_types[] = array('id' =>$key, 'text' =>  $val);
      }

    for ($i=1; $i<13; $i++) {
      $expires_month[] = array('id' => sprintf('%02d', $i), 'text' => strftime('%B',mktime(0,0,0,$i,1,2000)));
    }

    $today = getdate();
    for ($i=$today['year']; $i < $today['year']+10; $i++) {
      $expires_year[] = array('id' => strftime('%y',mktime(0,0,0,1,1,$i)), 'text' => strftime('%Y',mktime(0,0,0,1,1,$i)));
    }
	
	$selection = array('id' => $this->code,
                         'module' => $this->title,
                         'fields' => array(array('title' => MODULE_PAYMENT_PP3_CARD_TYPE,
                                                 'field' =>  tep_draw_pull_down_menu('cc_type', $cc_types))));
												 
    return $selection;
  }

  function pre_confirmation_check() {
    global $HTTP_POST_VARS, $customer_id, $order;

    if(!isset($_POST['cc_type']) || $_POST['cc_type'] == ''){
	$error = MODULE_PAYMENT_PP3_TEXT_ERROR_CARDTYPE;
	$payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($error);

        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
		
	} else {	
	
	$this->cc_card_number = $HTTP_POST_VARS['pp3_cc_number'];
	$this->ref = "REF".substr(md5(uniqid(rand(), true)), 0, 9);
    //$this->ref = $customer_id."-".date('YmdHis');

	$amount = $order->info['total'];

    tep_db_query("insert into pp3_data (ref, total_cost, currency, tm_password, order_state, sessionid) values ('".$this->ref."',$amount,'".substr(MODULE_PAYMENT_PP3_CURRENCY,-3)."','". md5(MODULE_PAYMENT_PP3_PASSWORD) ."','I','". tep_session_id() . "')");
	

    return false;
	}
  }

  function confirmation() {
    return;
    global $HTTP_POST_VARS;

    $confirmation = array('title' => $this->title . ': ' . $this->cc_card_type,
			  'fields' => array(array('title' => MODULE_PAYMENT_PP3_TEXT_CREDIT_CARD_OWNER,
						  'field' => $HTTP_POST_VARS['pp3_cc_owner']),
					    array('title' => MODULE_PAYMENT_PP3_TEXT_CREDIT_CARD_NUMBER,
						  'field' => substr($this->cc_card_number, 0, 4) . str_repeat('X', (strlen($this->cc_card_number) - 8)) . substr($this->cc_card_number, -4)),
					    array('title' => MODULE_PAYMENT_PP3_TEXT_CREDIT_CARD_EXPIRES, 'field' => strftime('%B, %Y', mktime(0,0,0,$HTTP_POST_VARS['pp3_cc_expires_month'], 1, '20' . $HTTP_POST_VARS['pp3_cc_expires_year'])))));
    
    return $confirmation;
  }

  function process_button() {
    global $HTTP_POST_VARS, $customer_id, $order, $currencies;
	
	$cc_type = $_POST['cc_type'];
	
	$customer_info = $this->customer();
	$customer_email = $customer_info['email'];
	
    $pp3_orderID = $this->ref;
    $mantisse2=array("0056"=>"1","0300"=>"1","0380"=>"1","0442"=>"1","0724"=>"1","0392"=>"1","0978"=>"2");
	
	$amount_standard = $order->info['total'];
	$pp3_amount = round($amount_standard * 100);
	
	$tm_description = iconv("ISO-8859-7", "UTF-8", MODULE_PAYMENT_PP3_MERCHANTDESC);
	
	
    $pp3_customername = $order->billing['firstname'] . ' ' . $order->billing['lastname'];
    $product_list = '';
    $count = 0;
    foreach ( $order->products as $product ) {
      if ( $count > 0 ) {
         $product_list .= ', ';
      } 
      $product_list .= $product['name'];
      $count++;
    }
    $product_list = trim ( $product_list );
    $process_button_string = 
	tep_draw_hidden_field ('transactiontype',  'authorisation' ) . 
	tep_draw_hidden_field ('merchantID',  MODULE_PAYMENT_PP3_MERCHANTID ) . 
	tep_draw_hidden_field ('amount', $pp3_amount ) . 
	tep_draw_hidden_field ('currency', MODULE_PAYMENT_PP3_CURRENCY ) . 
	tep_draw_hidden_field ('brand', $cc_type ) . 
	tep_draw_hidden_field ('merchantRef', $pp3_orderID ) . 
	tep_draw_hidden_field ('merchantDesc', $tm_description ) . 
	tep_draw_hidden_field ('language',  MODULE_PAYMENT_PP3_LANGUAGE ) . 
	tep_draw_hidden_field ('emailcustomer',  $customer_email ) . 
	tep_draw_hidden_field ('MerchantVar1',  'ERPFunction1_12') . 
	tep_draw_hidden_field ('MerchantVar2',  'ERPRef1_45') . 
	tep_draw_hidden_field ('MerchantVar3',  '');

/* NOTE, you can pass additional variables to ProxyPay by adding " . tep_draw_hidden_field ('VARNAME', $VARVALUE )" at the end, and before the semicolon (;), of the string above */

    return $process_button_string;
  }

  function before_process() {
    return false;
  }

  function after_process() {
    return false;
  }

  function get_error($error='') {
    global $HTTP_GET_VARS;
   
    if ( $error == "" ) {
       $error = $HTTP_GET_VARS['error'];
    }
 
    $error = array('title' => MODULE_PAYMENT_PP3_TEXT_ERROR,
		   'error' => stripslashes(urldecode($error)));
    
    return $error;
  }

  function output_error() {
    return false;
  }

  function check() {
    if (!isset($this->_check)) {
      $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PP3_STATUS'");
      $this->_check = tep_db_num_rows($check_query);
    }
    return $this->_check;
  }

  function install() {
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable PP3 Module', 'MODULE_PAYMENT_PP3_STATUS', 'True', 'Do you want to accept PP3 payments?', '6', '0', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('PP3 Sorting order', 'MODULE_PAYMENT_PP3_SORTORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '20', now())");	  	  
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchant ID', 'MODULE_PAYMENT_PP3_MERCHANTID', '', 'Merchant ID', '6', '22', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Client Language', 'MODULE_PAYMENT_PP3_LANGUAGE', 'EN', 'Client language', '6', '23', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('PP3 Module In Production', 'MODULE_PAYMENT_PP3_PRODUCTION', 'False', 'Enable the production url?', '6', '27', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");	  
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Currency', 'MODULE_PAYMENT_PP3_CURRENCY', '0978', 'The currency used for this shop (default 0978 for Euro)', '6', '26', now())");	  
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Test URL', 'MODULE_PAYMENT_PP3_TEST_URL', '', 'The test url for PP3', '6', '28', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Production URL', 'MODULE_PAYMENT_PP3_PROD_URL', '', 'The production url for PP3', '6', '29', now())");	
tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Production Password', 'MODULE_PAYMENT_PP3_PASSWORD', '', 'Transaction Password', '6', '30', now())");	
	    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchant Description', 'MODULE_PAYMENT_PP3_MERCHANTDESC', '', 'Short merchant description', '6', '31', now())"); 

tep_db_query("create table pp3_data (ref varchar(100) not null, total_cost decimal(14,6) not null, currency char(3) not null, tm_password varchar(100) not null, order_state char(1) not null, sessionid varchar(32) not null, primary key (ref, sessionid))");  
  }

  function remove() {
    tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");

    tep_db_query("drop table pp3_data");
  }

  function keys() {
    return array('MODULE_PAYMENT_PP3_STATUS', 'MODULE_PAYMENT_PP3_SORTORDER', 'MODULE_PAYMENT_PP3_MERCHANTID', 'MODULE_PAYMENT_PP3_MERCHANTDESC', 'MODULE_PAYMENT_PP3_PASSWORD', 'MODULE_PAYMENT_PP3_LANGUAGE', 'MODULE_PAYMENT_PP3_PRODUCTION', 'MODULE_PAYMENT_PP3_CURRENCY', 'MODULE_PAYMENT_PP3_TEST_URL', 'MODULE_PAYMENT_PP3_PROD_URL');
  }
}
?>
